<!DOCTYPE html>
<html lang="en">
<head>
  <title>63.20</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12">
		  <button id="add_data" class="btn btn-success mr-3">Add Data</button>
		  <button id="save_data" class="btn btn-info mr-3">Save Data</button>
		  <button id="delete_data" class="btn btn-warning mr-3">Delete Data</button>
		  <button id="delete_all_data" class="btn btn-danger mr-3">Delete All Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
</div>
<script>
	$(document).ready(function(){
		var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"maVoucher"},
				{"data":"phanTramGiamGia"},
				{"data":"ghiChu"},
				{"data":"ngayTao"},
				{"data":"ngayCapNhat"},
			]
		})

		callAjaxApiGetAllVouchers();

		function callAjaxApiGetAllVouchers() {
			$.ajax({
				url: "http://localhost:8080/api/vouchers",
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function(err) {
					console.log(err.response);
				}
			})
		}
		
		// khi click vào 1 row trong danh sách, sẽ load dữ liệu vào form, bằng cách gọi API (GET)	/api/voucher/:id
		$("#user-table").on("click", "td", function() {
			onTableRowClick(this);
		});

		var gVoucherId = 0;

		function onTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = table.row(vClickedRow).data();
			gVoucherId = vRowData.id;			
			console.log("Đã click vào row có id là: " + gVoucherId);
			callAjaxApiGetVoucherById(gVoucherId);
		}

		function callAjaxApiGetVoucherById(paramId) {
			$.ajax({
				url: "http://localhost:8080/api/vouchers/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadVoucherDataToForm(res);
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		function loadVoucherDataToForm(paramVoucher) {
			$("#input-voucher-code").val(paramVoucher.maVoucher);
			$("#input-discount").val(paramVoucher.phanTramGiamGia);
			$("#input-note").val(paramVoucher.ghiChu);
			$("#input-createDate").val(paramVoucher.ngayTao);
			$("#input-updateDate").val(paramVoucher.ngayCapNhat);
		}

		$("#save_data").on("click", function() {
			if(gVoucherId == 0) {
				alert("Chưa chọn Voucher nào");
			}
			else {
				var vVoucherData = readVoucherDataFromWeb();
				callAjaxApiUpdateVoucherById(gVoucherId, vVoucherData);
			}
		})

		function readVoucherDataFromWeb() {
			var vVoucherData = {
				maVoucher: $("#input-voucher-code").val(),
				phanTramGiamGia: $("#input-discount").val(),
				ghiChu: $("#input-note").val()
			};			
			console.log("Thông tin voucher đọc được là:");
			console.log(vVoucherData);
			return vVoucherData
		}

		function callAjaxApiUpdateVoucherById(paramId, paramVoucherData) {
			$.ajax({
				url: "http://localhost:8080/api/vouchers/" + paramId,
				type: "PUT",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramVoucherData),
				success: function(res) {
					console.log("Update thành công cho voucher có id " + paramId + ". Response là:");
					console.log(res);
					callAjaxApiGetAllVouchers();
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		$("#add_data").on("click", function() {
			gVoucherId = 0;
			var vVoucherData = readVoucherDataFromWeb();
			callAjaxApiAddNewVoucher(vVoucherData);
		})

		function callAjaxApiAddNewVoucher(paramVoucherData) {
			$.ajax({
				url: "http://localhost:8080/api/vouchers/",
				type: "POST",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramVoucherData),
				success: function(res) {
					console.log("Tạo voucher mới thành công. Response là:");
					console.log(res);
					callAjaxApiGetAllVouchers();
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		$("#delete_data").on("click", function() {
			if(gVoucherId == 0) {
				alert("Chưa chọn Voucher nào");
			}
			else {
				callAjaxApiDeleteVoucherById(gVoucherId);
			}
		})

		function callAjaxApiDeleteVoucherById(paramVoucherId) {
			$.ajax({
				url: "http://localhost:8080/api/vouchers/" + paramVoucherId,
				type: "DELETE",
				dataType: "json",
				success: function(res) {
					console.log("Xóa voucher có id " + paramVoucherId + " thành công. Response là:");
					console.log(res);
					callAjaxApiGetAllVouchers();
					gVoucherId = 0;
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		$("#delete_all_data").on("click", function() {
			callAjaxApiDeleteAllVouchers();
		})

		function callAjaxApiDeleteAllVouchers() {
			$.ajax({
				url: "http://localhost:8080/api/vouchers/",
				type: "DELETE",
				dataType: "json",
				success: function(res) {
					console.log("Xóa tất cả voucher thành công. Response là:");
					console.log(res);
					callAjaxApiGetAllVouchers();
					gVoucherId = 0;
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}
	})
</script>
</body>
</html>
